---
title: Expect
slug: Web/HTTP/Headers/Expect
tags:
  - HTTP
  - HTTP Header
  - Reference
  - Request header
---
<div>{{HTTPSidebar}}</div>

<p>The <strong><code>Expect</code></strong> HTTP request header indicates expectations that need to be fulfilled by the server in order to properly handle the request.</p>

<p>The only expectation defined in the specification is <code>Expect: 100-continue</code>, to which the server shall respond with:</p>

<ul>
 <li>{{HTTPStatus("100")}} if the information contained in the header is sufficient to cause an immediate success,</li>
 <li>{{HTTPStatus("417")}} (Expectation Failed) if it cannot meet the expectation; or any other 4xx status otherwise.</li>
</ul>

<p>For example, the server may reject a request if its {{HTTPHeader("Content-Length")}} is too large.</p>

<p>No common browsers send the <code>Expect</code> header, but some other clients such as cURL do so by default.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Header type</th>
   <td>{{Glossary("Request header")}}</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Forbidden header name")}}</th>
   <td>yes</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<p>No other expectations except "100-continue" are specified currently.</p>

<pre class="syntaxbox">Expect: 100-continue
</pre>

<h2 id="Directives">Directives</h2>

<dl>
 <dt>100-continue</dt>
 <dd>Informs recipients that the client is about to send a (presumably large) message body in this request and wishes to receive a {{HTTPStatus("100")}} (Continue) interim response.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Large_message_body">Large message body</h3>

<p>A client sends a request with a Expect header and waits for the server to respond before sending the message body.</p>

<pre>PUT /somewhere/fun HTTP/1.1
Host: origin.example.com
Content-Type: video/h264
Content-Length: 1234567890987
Expect: 100-continue
</pre>

<p>The server now checks the request headers and may respond with a {{HTTPStatus("100")}} (Continue) response to instruct the client to go ahead and send the message body, or it will send a {{HTTPStatus("417")}} (Expectation Failed) status if any of the expectations cannot be met.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Title</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{RFC("7231", "Expect", "5.1.1")}}</td>
   <td>Hypertext Transfer Protocol (HTTP/1.1): Semantics and Content</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("http.headers.Expect")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTTPStatus("417")}}<code> Expectation Failed</code></li>
 <li>{{HTTPStatus("100")}}<code> Continue</code></li>
</ul>
